Index: /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 543)
+++ /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 544)
@@ -64,14 +64,12 @@
     {
         "TGT_CMD_IDLE",
-        "TGT_CMD_ERROR",
         "TGT_CMD_READ",
         "TGT_CMD_WRITE",
         "TGT_CMD_CAS",
+        "TGT_CMD_ERROR",
         "TGT_CMD_CONFIG"
     };
     const char *tgt_rsp_fsm_str[] =
     {
-        "TGT_RSP_CONFIG_IDLE",
-        "TGT_RSP_TGT_CMD_IDLE",
         "TGT_RSP_READ_IDLE",
         "TGT_RSP_WRITE_IDLE",
@@ -80,6 +78,6 @@
         "TGT_RSP_MULTI_ACK_IDLE",
         "TGT_RSP_CLEANUP_IDLE",
-        "TGT_RSP_CONFIG",
-        "TGT_RSP_TGT_CMD",
+        "TGT_RSP_CONFIG_IDLE",
+        "TGT_RSP_TGT_CMD_IDLE",
         "TGT_RSP_READ",
         "TGT_RSP_WRITE",
@@ -87,5 +85,7 @@
         "TGT_RSP_XRAM",
         "TGT_RSP_MULTI_ACK",
-        "TGT_RSP_CLEANUP"
+        "TGT_RSP_CLEANUP",
+        "TGT_RSP_CONFIG",
+        "TGT_RSP_TGT_CMD"
     };
     const char *cc_receive_fsm_str[] =
@@ -98,12 +98,8 @@
     const char *cc_send_fsm_str[] =
     {
-        "CC_SEND_CONFIG_IDLE",
         "CC_SEND_XRAM_RSP_IDLE",
         "CC_SEND_WRITE_IDLE",
         "CC_SEND_CAS_IDLE",
-        "CC_SEND_CONFIG_INVAL_HEADER",
-        "CC_SEND_CONFIG_INVAL_NLINE",
-        "CC_SEND_CONFIG_BRDCAST_HEADER",
-        "CC_SEND_CONFIG_BRDCAST_NLINE",
+        "CC_SEND_CONFIG_IDLE",
         "CC_SEND_XRAM_RSP_BRDCAST_HEADER",
         "CC_SEND_XRAM_RSP_BRDCAST_NLINE",
@@ -120,5 +116,9 @@
         "CC_SEND_CAS_UPDT_NLINE",
         "CC_SEND_CAS_UPDT_DATA",
-        "CC_SEND_CAS_UPDT_DATA_HIGH"
+        "CC_SEND_CAS_UPDT_DATA_HIGH",
+        "CC_SEND_CONFIG_INVAL_HEADER",
+        "CC_SEND_CONFIG_INVAL_NLINE",
+        "CC_SEND_CONFIG_BRDCAST_HEADER",
+        "CC_SEND_CONFIG_BRDCAST_NLINE"
     };
     const char *multi_ack_fsm_str[] =
@@ -282,10 +282,10 @@
     {
         "ALLOC_DIR_RESET",
-        "ALLOC_DIR_CONFIG",
         "ALLOC_DIR_READ",
         "ALLOC_DIR_WRITE",
         "ALLOC_DIR_CAS",
         "ALLOC_DIR_CLEANUP",
-        "ALLOC_DIR_XRAM_RSP"
+        "ALLOC_DIR_XRAM_RSP",
+        "ALLOC_DIR_CONFIG"
     };
     const char *alloc_trt_fsm_str[] =
@@ -345,4 +345,6 @@
             const IntTab        &tgtid_d,          // global index on direct network
             const size_t        cc_global_id,      // global index on cc network
+            const size_t        x_width,           // number of x bits in platform
+            const size_t        y_width,           // number of x bits in platform
             const size_t        nways,             // number of ways per set
             const size_t        nsets,             // number of associative sets
@@ -377,4 +379,6 @@
         m_words( nwords ),
         m_cc_global_id( cc_global_id ),
+        m_xwidth(x_width),
+        m_ywidth(y_width),
         m_debug_start_cycle( debug_start_cycle ),
         m_debug_ok( debug_ok ),
@@ -470,4 +474,25 @@
         r_alloc_heap_fsm("r_alloc_heap_fsm"),
         r_alloc_heap_reset_cpt("r_alloc_heap_reset_cpt")
+#if MONITOR_MEMCACHE_FSM == 1
+        ,
+        p_read_fsm("p_read_fsm"), 
+        p_write_fsm("p_write_fsm"), 
+        p_xram_rsp_fsm("p_xram_rsp_fsm"), 
+        p_cas_fsm("p_cas_fsm"), 
+        p_cleanup_fsm("p_cleanup_fsm"), 
+        p_config_fsm("p_config_fsm"), 
+        p_alloc_heap_fsm("p_alloc_heap_fsm"), 
+        p_alloc_dir_fsm("p_alloc_dir_fsm"), 
+        p_alloc_trt_fsm("p_alloc_trt_fsm"), 
+        p_alloc_upt_fsm("p_alloc_upt_fsm"), 
+        p_alloc_ivt_fsm("p_alloc_ivt_fsm"), 
+        p_tgt_cmd_fsm("p_tgt_cmd_fsm"), 
+        p_tgt_rsp_fsm("p_tgt_rsp_fsm"), 
+        p_ixr_cmd_fsm("p_ixr_cmd_fsm"), 
+        p_ixr_rsp_fsm("p_ixr_rsp_fsm"), 
+        p_cc_send_fsm("p_cc_send_fsm"), 
+        p_cc_receive_fsm("p_cc_receive_fsm"),
+        p_multi_ack_fsm("p_multi_ack_fsm")
+#endif
         {
             std::cout << "  - Building VciMemCache : " << name << std::endl;
@@ -623,4 +648,27 @@
     }
 
+    
+    /////////////////////////////////////////////////////
+    tmpl(uint32_t)::req_distance(uint32_t req_srcid)
+    /////////////////////////////////////////////////////
+    {
+        const uint32_t srcid_width = vci_param_int::S;
+        uint8_t self_x_srcid = m_cc_global_id >> (srcid_width - m_xwidth);
+        uint8_t self_y_srcid = (m_cc_global_id >> (srcid_width - m_ywidth)) & ((1 << m_xwidth) - 1);
+
+        uint8_t x_srcid = req_srcid >> (srcid_width - m_xwidth);
+        uint8_t y_srcid = (req_srcid >> (srcid_width - m_ywidth - m_xwidth)) & ((1 << m_xwidth) - 1);
+        return abs(self_x_srcid - x_srcid) + abs(self_y_srcid - y_srcid);
+    }
+
+
+    /////////////////////////////////////////////////////
+    tmpl(bool)::is_local_req(uint32_t req_srcid)
+    /////////////////////////////////////////////////////
+    {
+        return req_distance(req_srcid) == 0;
+    }
+
+
     //////////////////////////////////////////////////
     tmpl(void) ::print_trace()
@@ -648,141 +696,119 @@
     }
 
+
     /////////////////////////////////////////
-    tmpl(void) ::clear_stats()
-        /////////////////////////////////////////
+    tmpl(void)::print_stats(bool activity_counters = true, bool stats = true)
     {
-        m_cpt_cycles                  = 0;
-        m_cpt_read                    = 0;
-        m_cpt_read_miss               = 0;
-        m_cpt_write                   = 0;
-        m_cpt_write_miss              = 0;
-        m_cpt_write_cells             = 0;
-        m_cpt_write_dirty             = 0;
-        m_cpt_update                  = 0;
-        m_cpt_update_mult             = 0;
-        m_cpt_inval_brdcast           = 0;
-        m_cpt_inval                   = 0;
-        m_cpt_inval_mult              = 0;
-        m_cpt_cleanup                 = 0;
-        m_cpt_cleanup_data            = 0;
-        m_cpt_ll                      = 0;
-        m_cpt_sc                      = 0;
-        m_cpt_cas                     = 0;
-        m_cpt_trt_full                = 0;
-        m_cpt_trt_rb                  = 0;
-        m_cpt_dir_unused              = 0;
-        m_cpt_ivt_unused              = 0;
-        m_cpt_heap_unused             = 0;
-        m_cpt_trt_unused              = 0;
-        m_cpt_read_fsm_n_dir_lock     = 0;
-        m_cpt_read_fsm_dir_lock       = 0;
-        m_cpt_read_fsm_dir_used       = 0;
-        m_cpt_read_fsm_trt_lock       = 0;
-        m_cpt_read_fsm_heap_lock      = 0;
-        m_cpt_write_fsm_dir_lock      = 0;
-        m_cpt_write_fsm_n_dir_lock    = 0;
-        m_cpt_write_fsm_upt_lock      = 0;
-        m_cpt_write_fsm_heap_lock     = 0;
-        m_cpt_write_fsm_dir_used      = 0;
-        m_cpt_write_fsm_trt_lock      = 0;
-        m_cpt_cas_fsm_n_dir_lock      = 0;
-        m_cpt_cas_fsm_dir_lock        = 0;
-        m_cpt_cas_fsm_upt_lock        = 0;
-        m_cpt_cas_fsm_heap_lock       = 0;
-        m_cpt_cas_fsm_trt_lock        = 0;
-        m_cpt_cas_fsm_dir_used        = 0;
-        m_cpt_xram_rsp_fsm_n_dir_lock = 0;
-        m_cpt_xram_rsp_fsm_dir_lock   = 0;
-        m_cpt_xram_rsp_fsm_trt_lock   = 0;
-        m_cpt_xram_rsp_fsm_upt_lock   = 0;
-        m_cpt_xram_rsp_fsm_heap_lock  = 0;
-        m_cpt_xram_rsp_fsm_dir_used   = 0;
-        m_cpt_cleanup_fsm_dir_lock    = 0;
-        m_cpt_cleanup_fsm_n_dir_lock  = 0;
-        m_cpt_cleanup_fsm_heap_lock   = 0;
-        m_cpt_cleanup_fsm_upt_lock    = 0;
-        m_cpt_cleanup_fsm_dir_used    = 0;
-        m_cpt_ixr_fsm_trt_lock        = 0;
-        m_cpt_multi_ack_fsm_upt_lock  = 0;
+        std::cout << "**********************************" << std::dec << std::endl;
+        std::cout << "*** MEM_CACHE " << name() << std::endl;
+        std::cout << "**********************************" << std::dec << std::endl;
+        if (activity_counters) {
+        std::cout << "----------------------------------" << std::dec << std::endl;
+            std::cout << "---     Activity Counters      ---" << std::dec << std::endl;
+            std::cout << "----------------------------------" << std::dec << std::endl;
+        std::cout
+                << "[001] NUMBER OF CYCLES          = " << m_cpt_cycles << std::endl
+                << std::endl
+                << "[002] LOCAL READ                = " << m_cpt_read_local << std::endl
+                << "[003] REMOTE READ               = " << m_cpt_read_remote << std::endl
+                << "[004] READ COST (FLITS * DIST)  = " << m_cpt_read_cost << std::endl
+                << std::endl
+                << "[005] LOCAL WRITE               = " << m_cpt_write_local << std::endl
+                << "[006] REMOTE WRITE              = " << m_cpt_write_remote << std::endl
+                << "[007] WRITE FLITS LOCAL         = " << m_cpt_write_flits_local << std::endl
+                << "[008] WRITE FLITS REMOTE        = " << m_cpt_write_flits_remote << std::endl
+                << "[009] WRITE COST (FLITS * DIST) = " << m_cpt_write_cost << std::endl
+                << std::endl
+                << "[010] LOCAL LL                  = " << m_cpt_ll_local << std::endl
+                << "[011] REMOTE LL                 = " << m_cpt_ll_remote << std::endl
+                << "[012] LL COST (FLITS * DIST)    = " << m_cpt_ll_cost << std::endl
+                << std::endl
+                << "[013] LOCAL SC                  = " << m_cpt_sc_local << std::endl
+                << "[014] REMOTE SC                 = " << m_cpt_sc_remote << std::endl
+                << "[015] SC COST (FLITS * DIST)    = " << m_cpt_sc_cost << std::endl
+                << std::endl
+                << "[016] LOCAL CAS                 = " << m_cpt_cas_local << std::endl
+                << "[017] REMOTE CAS                = " << m_cpt_cas_remote << std::endl
+                << "[018] CAS COST (FLITS * DIST)   = " << m_cpt_cas_cost << std::endl
+                << std::endl
+                << "[019] REQUESTS TRIG. UPDATE     = " << m_cpt_update << std::endl
+                << "[020] LOCAL UPDATE              = " << m_cpt_update_local << std::endl
+                << "[021] REMOTE UPDATE             = " << m_cpt_update_remote << std::endl
+                << "[022] UPDT COST (FLITS * DIST)  = " << m_cpt_update_cost << std::endl
+                << std::endl
+                << "[023] REQUESTS TRIG. M_INV      = " << m_cpt_m_inval << std::endl
+                << "[024] LOCAL M_INV               = " << m_cpt_m_inval_local << std::endl
+                << "[025] REMOTE M_INV              = " << m_cpt_m_inval_remote << std::endl
+                << "[026] M_INV COST (FLITS * DIST) = " << m_cpt_m_inval_cost << std::endl
+                << std::endl
+                << "[027] BROADCAT INVAL            = " << m_cpt_br_inval << std::endl
+                << std::endl
+                << "[028] LOCAL CLEANUP             = " << m_cpt_cleanup_local << std::endl
+                << "[029] REMOTE CLEANUP            = " << m_cpt_cleanup_remote << std::endl
+                << "[030] CLNUP COST (FLITS * DIST) = " << m_cpt_cleanup_cost << std::endl
+                << std::endl
+                << std::endl
+                << "[031] READ MISS                 = " << m_cpt_read_miss << std::endl
+                << "[032] WRITE MISS                = " << m_cpt_write_miss << std::endl
+                << "[033] WRITE DIRTY               = " << m_cpt_write_dirty << std::endl
+                << "[034] RD BLOCKED BY HIT IN TRT  = " << m_cpt_trt_rb << std::endl
+                << "[035] TRANS BLOCKED BY FULL TRT = " << m_cpt_trt_full << std::endl
+                << "[036] PUT (UNIMPLEMENTED)       = " << m_cpt_put << std::endl
+                << "[037] GET (UNIMPLEMENTED)       = " << m_cpt_get << std::endl
+                << "[038] WRITE BROADCAST           = " << m_cpt_write_broadcast << std::endl
+                << std::endl;
     }
-    /////////////////////////////////////////
-    tmpl(void) ::print_stats()
-        /////////////////////////////////////////
-    {
-        std::cout << "----------------------------------" << std::dec << std::endl;
-        std::cout
-            << "MEM_CACHE " << name() << " / Time = " << m_cpt_cycles << std::endl
-            << "- READ RATE                              = " << (double) m_cpt_read/m_cpt_cycles << std::endl
-            << "- READ TOTAL                             = " << m_cpt_read << std::endl
-            << "- READ MISS RATE                         = " << (double) m_cpt_read_miss/m_cpt_read << std::endl
-            << "- WRITE RATE                             = " << (double) m_cpt_write/m_cpt_cycles << std::endl
-            << "- WRITE TOTAL                            = " << m_cpt_write << std::endl
-            << "- WRITE MISS RATE                        = " << (double) m_cpt_write_miss/m_cpt_write << std::endl
-            << "- WRITE BURST LENGTH                     = " << (double) m_cpt_write_cells/m_cpt_write << std::endl
-            << "- WRITE BURST TOTAL                      = " << m_cpt_write_cells << std::endl
-            << "- REQUESTS TRT FULL                      = " << m_cpt_trt_full << std::endl
-            << "- READ TRT BLOKED HIT                    = " << m_cpt_trt_rb << std::endl
-            << "- UPDATE RATE                            = " << (double) m_cpt_update/m_cpt_cycles << std::endl
-            << "- UPDATE ARITY                           = " << (double) m_cpt_update_mult/m_cpt_update << std::endl
-            << "- INVAL MULTICAST RATE                   = " << (double)(m_cpt_inval-m_cpt_inval_brdcast) /m_cpt_cycles << std::endl
-            << "- INVAL MULTICAST ARITY                  = " << (double) m_cpt_inval_mult/ (m_cpt_inval-m_cpt_inval_brdcast) << std::endl
-            << "- INVAL BROADCAST RATE                   = " << (double) m_cpt_inval_brdcast/m_cpt_cycles << std::endl
-            << "- SAVE DIRTY RATE                        = " << (double) m_cpt_write_dirty/m_cpt_cycles << std::endl
-            << "- CLEANUP RATE                           = " << (double) m_cpt_cleanup/m_cpt_cycles << std::endl
-            << "- CLEANUP TOTAL                          = " << (double) m_cpt_cleanup << std::endl
-            << "- CLEANUP WITH DATA RATE                 = " << (double) m_cpt_cleanup_data/m_cpt_cycles << std::endl
-            << "- CLEANUP WITH DATA TOTAL                = " << (double) m_cpt_cleanup_data << std::endl
-            << "- LL RATE                                = " << (double) m_cpt_ll/m_cpt_cycles << std::endl
-            << "- SC RATE                                = " << (double) m_cpt_sc/m_cpt_cycles << std::endl
-            << "- CAS RATE                               = " << (double) m_cpt_cas/m_cpt_cycles << std::endl << std::endl;
-
-        /* << "- WAIT DIR LOCK in READ_FSM              = " << (double) m_cpt_read_fsm_dir_lock/m_cpt_read_fsm_n_dir_lock << std::endl
-           << "- NB CYCLES IN DIR LOCK in READ_FSM      = " << (double) m_cpt_read_fsm_dir_used/m_cpt_read_fsm_n_dir_lock << std::endl
-           << "- WAIT DIR LOCK in WRITE_FSM             = " << (double) m_cpt_write_fsm_dir_lock/m_cpt_write_fsm_n_dir_lock << std::endl
-           << "- NB CYCLES IN DIR LOCK in WRITE_FSM     = " << (double) m_cpt_write_fsm_dir_used/m_cpt_write_fsm_n_dir_lock << std::endl
-           << "- WAIT DIR LOCK in XRAM_FSM              = " << (double) m_cpt_xram_rsp_fsm_dir_lock/m_cpt_xram_rsp_fsm_n_dir_lock << std::endl
-           << "- NB CYCLES IN DIR LOCK in XRAM_FSM      = " << (double) m_cpt_xram_rsp_fsm_dir_used/m_cpt_xram_rsp_fsm_n_dir_lock << std::endl
-           << "- WAIT DIR LOCK in CLEANUP_FSM           = " << (double) m_cpt_cleanup_fsm_dir_lock/m_cpt_cleanup_fsm_n_dir_lock << std::endl
-           << "- NB CYCLES IN DIR LOCK in CLEANUP_FSM   = " << (double) m_cpt_cleanup_fsm_dir_used/m_cpt_cleanup_fsm_n_dir_lock << std::endl
-           << "- WAIT DIR LOCK in CAS_FSM               = " << (double) m_cpt_cas_fsm_dir_lock/m_cpt_cas_fsm_n_dir_lock << std::endl
-           << "- NB CYCLES IN LOCK in CAS_FSM           = " << (double) m_cpt_cas_fsm_dir_used/m_cpt_cas_fsm_n_dir_lock << std::endl
-           << "- DIR UNUSED RATE                        = " << (double) m_cpt_dir_unused/m_cpt_cycles << std::endl << std::endl
-
-           << "- WAIT TRT LOCK in READ_FSM              = " << (double) m_cpt_read_fsm_trt_lock/m_cpt_read_fsm_n_trt_lock << std::endl
-           << "- NB CYCLES IN TRT LOCK in READ_FSM      = " << (double) m_cpt_read_fsm_trt_used/m_cpt_read_fsm_n_trt_lock << std::endl
-           << "- WAIT TRT LOCK in WRITE_FSM             = " << (double) m_cpt_write_fsm_trt_lock/m_cpt_write_fsm_n_trt_lock << std::endl
-           << "- NB CYCLES IN TRT LOCK in WRITE_FSM     = " << (double) m_cpt_write_fsm_trt_used/m_cpt_write_fsm_n_trt_lock << std::endl
-           << "- WAIT TRT LOCK in CAS_FSM               = " << (double) m_cpt_cas_fsm_trt_lock/m_cpt_cas_fsm_n_trt_lock << std::endl
-           << "- NB CYCLES IN TRT LOCK in CAS_FSM       = " << (double) m_cpt_cas_fsm_trt_used/m_cpt_cas_fsm_n_trt_lock << std::endl
-           << "- WAIT TRT LOCK in XRAM_FSM              = " << (double) m_cpt_xram_rsp_fsm_trt_lock/m_cpt_xram_rsp_fsm_n_trt_lock << std::endl
-           << "- NB CYCLES IN TRT LOCK in XRAM_FSM      = " << (double) m_cpt_xram_rsp_fsm_trt_used/m_cpt_xram_rsp_fsm_n_trt_lock << std::endl
-           << "- WAIT TRT LOCK in IXR_FSM               = " << (double) m_cpt_ixr_fsm_trt_lock/m_cpt_ixr_fsm_n_trt_lock << std::endl
-           << "- NB CYCLES IN TRT LOCK in IXR_FSM       = " << (double) m_cpt_ixr_fsm_trt_used/m_cpt_ixr_fsm_n_trt_lock << std::endl
-           << "- TRT UNUSED RATE                        = " << (double) m_cpt_trt_unused/m_cpt_cycles << std::endl << std::endl
-
-           << "- WAIT UPT LOCK in WRITE_FSM             = " << (double) m_cpt_write_fsm_upt_lock/m_cpt_write_fsm_n_upt_lock << std::endl
-           << "- NB CYCLES IN UPT LOCK in WRITE_FSM     = " << (double) m_cpt_write_fsm_upt_used/m_cpt_write_fsm_n_upt_lock << std::endl
-           << "- WAIT UPT LOCK in XRAM_FSM              = " << (double) m_cpt_xram_rsp_fsm_upt_lock/m_cpt_xram_rsp_fsm_n_upt_lock << std::endl
-           << "- NB CYCLES IN UPT LOCK in XRAM_FSM      = " << (double) m_cpt_xram_rsp_fsm_upt_used/m_cpt_xram_rsp_fsm_n_upt_lock << std::endl
-           << "- WAIT UPT LOCK in MULTIACK_FSM          = " << (double) m_cpt_multi_ack_fsm_upt_lock/m_cpt_multi_ack_fsm_n_upt_lock << std::endl
-           << "- NB CYCLES IN UPT LOCK in MULTIACK_FSM  = " << (double) m_cpt_multi_ack_fsm_upt_used/m_cpt_multi_ack_fsm_n_upt_lock << std::endl
-           << "- WAIT UPT LOCK in CLEANUP_FSM           = " << (double) m_cpt_cleanup_fsm_upt_lock/m_cpt_cleanup_fsm_n_upt_lock << std::endl
-           << "- NB CYCLES IN UPT LOCK in CLEANUP_FSM   = " << (double) m_cpt_cleanup_fsm_upt_used/m_cpt_cleanup_fsm_n_upt_lock << std::endl
-           << "- WAIT UPT LOCK in CAS_FSM               = " << (double) m_cpt_cas_fsm_upt_lock/m_cpt_cas_fsm_n_upt_lock << std::endl
-           << "- NB CYCLES IN UPT LOCK in CAS_FSM       = " << (double) m_cpt_cas_fsm_upt_used/m_cpt_cas_fsm_n_upt_lock << std::endl
-           << "- IVT UNUSED RATE                        = " << (double) m_cpt_ivt_unused/m_cpt_cycles << std::endl << std::endl
-
-           << "- WAIT HEAP LOCK in READ_FSM             = " << (double) m_cpt_read_fsm_heap_lock/m_cpt_read_fsm_n_heap_lock << std::endl
-           << "- NB CYCLES IN HEAP LOCK in READ_FSM     = " << (double) m_cpt_read_fsm_heap_used/m_cpt_read_fsm_n_heap_lock << std::endl
-           << "- WAIT HEAP LOCK in WRITE_FSM            = " << (double) m_cpt_write_fsm_heap_lock/m_cpt_write_fsm_n_heap_lock << std::endl
-           << "- NB CYCLES IN HEAP LOCK in WRITE_FSM    = " << (double) m_cpt_write_fsm_heap_used/m_cpt_write_fsm_n_heap_lock << std::endl
-           << "- WAIT HEAP LOCK in XRAM_FSM             = " << (double) m_cpt_xram_rsp_fsm_heap_lock/m_cpt_xram_rsp_fsm_n_heap_lock << std::endl
-           << "- NB CYCLES IN HEAP LOCK in XRAM_FSM     = " << (double) m_cpt_xram_rsp_fsm_heap_used/m_cpt_xram_rsp_fsm_n_heap_lock << std::endl
-           << "- WAIT HEAP LOCK in CLEANUP_FSM          = " << (double) m_cpt_cleanup_fsm_heap_lock/m_cpt_cleanup_fsm_n_heap_lock << std::endl
-           << "- NB CYCLES IN HEAP LOCK in CLEANUP_FSM  = " << (double) m_cpt_cleanup_fsm_heap_used/m_cpt_cleanup_fsm_n_heap_lock << std::endl
-           << "- WAIT HEAP LOCK in CAS_FSM              = " << (double) m_cpt_cas_fsm_heap_lock/m_cpt_cas_fsm_n_heap_lock << std::endl
-           << "- NB CYCLES IN HEAP LOCK in CAS_FSM      = " << (double) m_cpt_cas_fsm_heap_used/m_cpt_cas_fsm_n_heap_lock << std::endl
-           << "- HEAP UNUSED RATE                       = " << (double) m_cpt_heap_unused/m_cpt_cycles << std::endl;*/
+
+        if (stats) {
+            std::cout << "----------------------------------" << std::dec << std::endl;
+            std::cout << "---      Calculated Stats      ---" << std::dec << std::endl;
+            std::cout << "----------------------------------" << std::dec << std::endl;
+            std::cout
+                << "[100] READ TOTAL            = " << m_cpt_read_local + m_cpt_read_remote << std::endl
+                << "[101] READ RATE             = " << (double) (m_cpt_read_local + m_cpt_read_remote) / m_cpt_cycles << std::endl
+                << "[102] LOCAL READ RATE       = " << (double) m_cpt_read_local / m_cpt_cycles << std::endl
+                << "[103] REMOTE READ RATE      = " << (double) m_cpt_read_remote / m_cpt_cycles << std::endl
+                << "[104] READ MISS RATE        = " << (double) m_cpt_read_miss / (m_cpt_read_local + m_cpt_read_remote) << std::endl
+                << std::endl
+                << "[105] WRITE TOTAL           = " << m_cpt_write_local + m_cpt_write_remote << std::endl
+                << "[106] WRITE RATE            = " << (double) (m_cpt_write_local + m_cpt_write_remote) / m_cpt_cycles << std::endl
+                << "[107] LOCAL WRITE RATE      = " << (double) m_cpt_write_local / m_cpt_cycles << std::endl
+                << "[108] REMOTE WRITE RATE     = " << (double) m_cpt_write_remote / m_cpt_cycles << std::endl
+                << "[109] WRITE MISS RATE       = " << (double) m_cpt_write_miss / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << "[110] WRITE BURST TOTAL     = " << m_cpt_write_flits_local + m_cpt_write_flits_remote << std::endl
+                << "[111] WRITE BURST AVERAGE   = " << (double) (m_cpt_write_flits_local + m_cpt_write_flits_remote) / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << "[112] LOCAL WRITE BURST AV. = " << (double) m_cpt_write_flits_local / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << "[113] REMOTE WRITE BURST AV = " << (double) m_cpt_write_flits_remote / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << std::endl
+                << "[114] UPDATE RATE                = " << (double) m_cpt_update / m_cpt_cycles << std::endl
+                << "[115] AV. UPDATE PER UP REQ      = " << (double) (m_cpt_update_local + m_cpt_update_remote) / m_cpt_update << std::endl
+                << "[116] AV. LOC UPDT PER UP REQ    = " << (double) m_cpt_update_local / m_cpt_update << std::endl
+                << "[117] AV. REMOTE UPDT PER UP REQ = " << (double) m_cpt_update_remote / m_cpt_update << std::endl
+                << std::endl
+                << "[118] INVAL MULTICAST RATE  = " << (double) m_cpt_m_inval / m_cpt_cycles << std::endl
+                << "[119] AVE. INVAL PER M_INV  = " << (double) (m_cpt_m_inval_local + m_cpt_m_inval_remote) / m_cpt_m_inval << std::endl
+                << "[120] AV. LOC INV PER M_INV = " << (double) m_cpt_m_inval_local / m_cpt_m_inval << std::endl
+                << "[121] AV. REM INV PER M_INV = " << (double) m_cpt_m_inval_remote / m_cpt_m_inval << std::endl
+                << std::endl
+                << "[122] INVAL BROADCAST RATE  = " << (double) m_cpt_br_inval / m_cpt_cycles << std::endl
+                << "[123] WRITE DIRTY RATE      = " << (double) m_cpt_write_dirty / m_cpt_cycles << std::endl
+                << std::endl
+                << "[124] CLEANUP RATE          = " << (double) (m_cpt_cleanup_local + m_cpt_cleanup_remote) / m_cpt_cycles << std::endl
+                << "[125] LOCAL CLEANUP RATE    = " << (double) m_cpt_cleanup_local / m_cpt_cycles << std::endl
+                << "[126] REMOTE CLEANUP RATE   = " << (double) m_cpt_cleanup_remote / m_cpt_cycles << std::endl
+                << "[127] LL RATE               = " << (double) (m_cpt_ll_local + m_cpt_ll_remote) / m_cpt_cycles << std::endl
+                << "[128] LOCAL LL RATE         = " << (double) m_cpt_ll_local / m_cpt_cycles << std::endl
+                << "[129] REMOTE LL RATE        = " << (double) m_cpt_ll_remote / m_cpt_cycles << std::endl
+                << "[130] SC RATE               = " << (double) (m_cpt_sc_local + m_cpt_sc_remote) / m_cpt_cycles << std::endl
+                << "[131] LOCAL SC RATE         = " << (double) m_cpt_sc_local / m_cpt_cycles << std::endl
+                << "[132] REMOTE SC RATE        = " << (double) m_cpt_sc_remote / m_cpt_cycles << std::endl
+                << "[133] CAS RATE              = " << (double) (m_cpt_cas_local + m_cpt_cas_remote) / m_cpt_cycles << std::endl
+                << "[134] LOCAL CAS RATE        = " << (double) m_cpt_cas_local / m_cpt_cycles << std::endl
+                << "[135] REMOTE CAS RATE       = " << (double) m_cpt_cas_remote / m_cpt_cycles << std::endl
+                << std::endl
+                << std::endl;
+        }
     }
+
 
     /////////////////////////////////
@@ -790,7 +816,7 @@
         /////////////////////////////////
     {
+        delete [] m_seg;
+
         delete [] r_ixr_rsp_to_xram_rsp_rok;
-        //delete [] r_ixr_rsp_to_xram_rsp_no_coherent;
-
         delete [] r_xram_rsp_victim_data;
         delete [] r_xram_rsp_to_tgt_rsp_data;
@@ -802,8 +828,17 @@
         delete [] r_write_be;
         delete [] r_write_to_cc_send_data;
+        delete [] r_write_to_cc_send_be;
 
         delete [] r_cleanup_data;
-        delete [] r_ixr_cmd_data;
         delete [] r_cleanup_to_ixr_cmd_data;
+
+        delete [] r_cas_data;
+        delete [] r_cas_rdata;
+
+        delete [] r_ixr_cmd_wdata;
+        delete [] m_debug_previous_data;
+        delete [] m_debug_data;
+
+        print_stats();
     }
 
@@ -821,5 +856,5 @@
             r_tgt_cmd_fsm    = TGT_CMD_IDLE;
             r_config_fsm     = CONFIG_IDLE;
-            r_tgt_rsp_fsm    = TGT_RSP_TGT_CMD_IDLE;
+            r_tgt_rsp_fsm    = TGT_RSP_READ_IDLE;
             r_cc_send_fsm    = CC_SEND_XRAM_RSP_IDLE;
             r_cc_receive_fsm = CC_RECEIVE_IDLE;
@@ -833,5 +868,5 @@
             r_alloc_trt_fsm  = ALLOC_TRT_READ;
             r_alloc_upt_fsm  = ALLOC_UPT_WRITE;
-            r_alloc_ivt_fsm  = ALLOC_IVT_XRAM_RSP;
+            r_alloc_ivt_fsm  = ALLOC_IVT_WRITE;
             r_ixr_rsp_fsm    = IXR_RSP_IDLE;
             r_xram_rsp_fsm   = XRAM_RSP_IDLE;
@@ -951,9 +986,36 @@
             // Activity counters
             m_cpt_cycles                  = 0;
-            m_cpt_read                    = 0;
+            m_cpt_read_local         = 0;
+            m_cpt_read_remote        = 0;
+            m_cpt_read_cost          = 0;
+            m_cpt_write_local        = 0;
+            m_cpt_write_remote       = 0;
+            m_cpt_write_flits_local  = 0;
+            m_cpt_write_flits_remote = 0;
+            m_cpt_write_cost         = 0;
+            m_cpt_ll_local           = 0;
+            m_cpt_ll_remote          = 0;
+            m_cpt_ll_cost            = 0;
+            m_cpt_sc_local           = 0;
+            m_cpt_sc_remote          = 0;
+            m_cpt_sc_cost            = 0;
+            m_cpt_cas_local          = 0;
+            m_cpt_cas_remote         = 0;
+            m_cpt_cas_cost           = 0;
+            m_cpt_update             = 0;
+            m_cpt_update_local       = 0;
+            m_cpt_update_remote      = 0;
+            m_cpt_update_cost        = 0;
+            m_cpt_m_inval            = 0;
+            m_cpt_m_inval_local      = 0;
+            m_cpt_m_inval_remote     = 0;
+            m_cpt_m_inval_cost       = 0;
+            m_cpt_br_inval           = 0;
+            m_cpt_cleanup_local      = 0;
+            m_cpt_cleanup_remote     = 0;
+            m_cpt_cleanup_cost       = 0;
+
             m_cpt_read_miss               = 0;
-            m_cpt_write                   = 0;
             m_cpt_write_miss              = 0;
-            m_cpt_write_cells             = 0;
             m_cpt_write_dirty             = 0;
             m_cpt_update                  = 0;
@@ -967,6 +1029,9 @@
             m_cpt_sc                      = 0;
             m_cpt_cas                     = 0;
+            m_cpt_write_broadcast         = 0;
+            m_cpt_trt_rb                  = 0;
             m_cpt_trt_full                = 0;
-            m_cpt_trt_rb                  = 0;
+            m_cpt_get                     = 0;
+            m_cpt_put                     = 0;
             m_cpt_dir_unused              = 0;
             m_cpt_ivt_unused              = 0;
@@ -1092,5 +1157,4 @@
         ////////////////////////////////////////////////////////////////////////////////////
 
-        //std::cout << std::endl << "tgt_cmd_fsm" << std::endl;
 
         switch(r_tgt_cmd_fsm.read())
@@ -1114,12 +1178,7 @@
                     bool        config   = false;
 
-                    // register arguments for response (segmentation violation or config)
-                    r_tgt_cmd_to_tgt_rsp_srcid = p_vci_tgt.srcid.read();
-                    r_tgt_cmd_to_tgt_rsp_trdid = p_vci_tgt.trdid.read();
-                    r_tgt_cmd_to_tgt_rsp_pktid = p_vci_tgt.pktid.read();
-
-                    for(size_t seg_id = 0 ; (seg_id < m_nseg) and not found ; seg_id++)
-                    {
-                        if( m_seg[seg_id]->contains(address) and
+                    for (size_t seg_id = 0; (seg_id < m_nseg) && !found; seg_id++)
+                    {
+                        if (m_seg[seg_id]->contains(address) &&
                                 m_seg[seg_id]->contains(address + plen - vci_param_int::B) )
                         {
@@ -1129,5 +1188,5 @@
                     }
 
-                    if ( not found )                /////////// out of segment error
+                    if (!found)                /////////// out of segment error
                     {
                         r_tgt_cmd_fsm   = TGT_CMD_ERROR;
@@ -1135,5 +1194,5 @@
                     else if ( config )              /////////// configuration command
                     {
-                        if ( not p_vci_tgt.eop.read() ) r_tgt_cmd_fsm = TGT_CMD_ERROR;
+                        if (!p_vci_tgt.eop.read()) r_tgt_cmd_fsm = TGT_CMD_ERROR;
                         else                            r_tgt_cmd_fsm = TGT_CMD_CONFIG;
                     }
@@ -1202,4 +1261,7 @@
                 if ( p_vci_tgt.cmdval and p_vci_tgt.eop )
                 {
+                    r_tgt_cmd_to_tgt_rsp_srcid = p_vci_tgt.srcid.read();
+                    r_tgt_cmd_to_tgt_rsp_trdid = p_vci_tgt.trdid.read();
+                    r_tgt_cmd_to_tgt_rsp_pktid = p_vci_tgt.pktid.read();
                     r_tgt_cmd_to_tgt_rsp_req   = true;
                     r_tgt_cmd_to_tgt_rsp_error = 1;
